# TODO
# - should mailq and newaliases be in bindir?
#
# Conditional build:
%bcond_without	pam		# build without PAM support
%bcond_without	table_db	# build table-db backend

Summary:	Free implementation of the server-side SMTP protocol as defined by RFC 5321
Summary(pl.UTF-8):	Wolnodostępna implementacja strony serwerowej protokołu SMTP wg RFC 5321
Name:		opensmtpd
Version:	6.8.0p2
Release:	1
License:	ISC
Group:		Daemons
Source0:	https://www.opensmtpd.org/archives/%{name}-%{version}.tar.gz
# Source0-md5:	57209fc2bedf540b4649a42eb95341c5
Source1:	%{name}.service
Source2:	%{name}.init
Source3:	%{name}.pam
Source4:	aliases
Patch0:		%{name}-ac.patch
URL:		https://www.opensmtpd.org/
BuildRequires:	autoconf >= 2.69
BuildRequires:	automake
BuildRequires:	bison
%{?with_table_db:BuildRequires:	db-devel}
BuildRequires:	libasr-devel
BuildRequires:	libevent-devel
BuildRequires:	libtool >= 2:2
BuildRequires:	openssl-devel
%{?with_pam:BuildRequires:	pam-devel}
BuildRequires:	rpmbuild(macros) >= 1.228
BuildRequires:	zlib-devel
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires:	rc-scripts
Suggests:	ca-certificates
Provides:	group(smtpd)
Provides:	group(smtpq)
Provides:	smtpdaemon
Provides:	user(smtpd)
Provides:	user(smtpq)
Obsoletes:	smtpdaemon
%requires_ge_to	openssl	openssl-devel
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		privsepdir	/usr/share/empty
%define		spooldir	/var/spool/smtpd
%define		certsdir	/etc/certs

%description
OpenSMTPD is a FREE implementation of the server-side SMTP protocol as
defined by RFC 5321, with some additional standard extensions. It
allows ordinary machines to exchange e-mails with other systems
speaking the SMTP protocol.

Started out of dissatisfaction with other implementations, OpenSMTPD
nowadays is a fairly complete SMTP implementation. OpenSMTPD is
primarily developed by Gilles Chehade, Eric Faurot and Charles
Longeau; with contributions from various OpenBSD hackers. OpenSMTPD is
part of the OpenBSD Project. The software is freely usable and
re-usable by everyone under an ISC license.

%prep
%setup -q
%patch0 -p1

%build
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	--sysconfdir=%{_sysconfdir}/mail \
	%{?with_pam:--with-auth-pam=smtp} \
	--with-group-queue=smtpq \
	--with-mantype=man \
	--with-path-CAfile=%{certsdir}/ca-certificates.crt \
	--with-path-empty=%{privsepdir} \
	%{?with_table_db:--with-table-db} \
	--with-user-queue=smtpq \
	--with-user-smtpd=smtpd

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT{%{systemdunitdir},/etc/{rc.d/init.d,pam.d}}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{systemdunitdir}/opensmtpd.service
install -p %{SOURCE2} $RPM_BUILD_ROOT/etc/rc.d/init.d/opensmtpd
cp -p %{SOURCE4} $RPM_BUILD_ROOT/etc/mail
%if %{with pam}
cp -p %{SOURCE3} $RPM_BUILD_ROOT/etc/pam.d/smtp
%endif
touch $RPM_BUILD_ROOT%{_sysconfdir}/mail/aliases.db

install -d $RPM_BUILD_ROOT%{_prefix}/lib
ln -s %{_sbindir}/smtpctl $RPM_BUILD_ROOT%{_prefix}/lib/sendmail

# other utils
ln -s %{_sbindir}/smtpctl $RPM_BUILD_ROOT%{_sbindir}/mailq
ln -s %{_sbindir}/smtpctl $RPM_BUILD_ROOT%{_sbindir}/sendmail
%if %{with table_db}
ln -s %{_sbindir}/smtpctl $RPM_BUILD_ROOT%{_sbindir}/makemap
ln -s %{_sbindir}/smtpctl $RPM_BUILD_ROOT%{_sbindir}/newaliases
%endif

# queue dirs
install -d $RPM_BUILD_ROOT%{spooldir}/{queue,corrupt,incoming,offline,purge,temporary}

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 297 smtpd
%groupadd -g 298 smtpq
%useradd -u 297 -g smtpd -s /sbin/nologin -c "OpenSMTPd privsep user" -d %{privsepdir} smtpd
%useradd -u 298 -g smtpq -s /sbin/nologin -c "OpenSMTPd queue user" -d %{privsepdir} smtpq

%post
/sbin/chkconfig --add %{name}
%service %{name} restart
%systemd_post %{name}.service

%preun
if [ $1 = 0 ]; then
	%service %{name} stop
	/sbin/chkconfig --del %{name}
fi
%systemd_preun %{name}.service

%postun
if [ "$1" = "0" ]; then
	%userremove smtpd
	%userremove smtpq
	%groupremove smtpd
	%groupremove smtpq
fi
%systemd_reload

%files
%defattr(644,root,root,755)
%doc LICENSE README.md
%dir %{_sysconfdir}/mail
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/mail/smtpd.conf
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/mail/aliases
%if %{with table_db}
%ghost %{_sysconfdir}/mail/aliases.db
%endif
%if %{with pam}
%config(noreplace) %verify(not md5 mtime size) /etc/pam.d/smtp
%endif
%attr(754,root,root) /etc/rc.d/init.d/opensmtpd
%{systemdunitdir}/%{name}.service
%attr(755,root,root) %{_bindir}/smtp
%attr(755,root,root) %{_sbindir}/mailq
%attr(755,root,root) %{_sbindir}/sendmail
%attr(755,root,root) %{_sbindir}/smtpctl
%attr(755,root,root) %{_sbindir}/smtpd
%attr(755,root,root) %{_prefix}/lib/sendmail
%{_mandir}/man1/smtp.1*
%{_mandir}/man5/aliases.5*
%{_mandir}/man5/forward.5*
%{_mandir}/man5/smtpd.conf.5*
%{_mandir}/man5/table.5*
%{_mandir}/man8/sendmail.8*
%{_mandir}/man8/smtpctl.8*
%{_mandir}/man8/smtpd.8*

%if %{with table_db}
%attr(755,root,root) %{_sbindir}/makemap
%attr(755,root,root) %{_sbindir}/newaliases
%{_mandir}/man8/makemap.8*
%{_mandir}/man8/newaliases.8*
%endif

%dir %{_libexecdir}/%{name}
%attr(755,root,root) %{_libexecdir}/%{name}/encrypt
%attr(755,root,root) %{_libexecdir}/%{name}/lockspool
%attr(755,root,root) %{_libexecdir}/%{name}/mail.lmtp
%attr(755,root,root) %{_libexecdir}/%{name}/mail.local
%attr(755,root,root) %{_libexecdir}/%{name}/mail.maildir
%attr(755,root,root) %{_libexecdir}/%{name}/mail.mboxfile
%attr(755,root,root) %{_libexecdir}/%{name}/mail.mda

%dir %attr(711,root,root) %{spooldir}
%dir %attr(770,root,smtpq) %{spooldir}/offline
%dir %attr(700,smtpq,root) %{spooldir}/corrupt
%dir %attr(700,smtpq,root) %{spooldir}/incoming
%dir %attr(700,smtpq,root) %{spooldir}/purge
%dir %attr(700,smtpq,root) %{spooldir}/queue
%dir %attr(700,smtpq,root) %{spooldir}/temporary
%changelog
* Thu Oct 14 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/opensmtpd.git;a=log;h=master

* Thu Oct 14 2021 Jan Rękorajski <baggins@pld-linux.org> f23f953
- up to 6.8.0p2

* Mon Mar 02 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> 417386e
- up to 6.6.4p1; fixes remote CVE-2020-8794

* Sat Feb 08 2020 Jan Rękorajski <baggins@pld-linux.org> 6083b58
- rebuild with libevent 2.1.11
- release 2 (by relup.sh)

* Wed Jan 29 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> b45fa11
- up to 6.6.2p1; fixes local and remote root hole - CVE-2020-7247

* Wed Oct 09 2019 Jakub Bogusz <qboosh@pld-linux.org> 9325868
- offline dir permissions fix from Stacho Pal; release 3

* Wed Oct 02 2019 Jakub Bogusz <qboosh@pld-linux.org> e20ff7b
- specify path to privsepdir; release 2

* Sat Sep 28 2019 Jakub Bogusz <qboosh@pld-linux.org> e31b6fd
- updated to 6.4.2p1
- added openssl1.1 patch (git fix to allow openssl again, not just libressl)
- added ac patch (fix wrong test arguments)
- fixed configure options
- /usr/sbin/sendmail is specified as required by FHS 3.0 footnote

* Sat Sep 22 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 82e2c35
- up to 6.0.3p1

* Sat Sep 15 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 8dd3051
- release 4 (by relup.sh)

* Sun Apr 02 2017 Jan Rękorajski <baggins@pld-linux.org> e992884
- rebuild with libevent 2.1.9
- release 3 (by relup.sh)

* Sun Mar 06 2016 Elan Ruusamäe <glen@delfi.ee> 94d27da
- depend on openssl version

* Sun Mar 06 2016 Elan Ruusamäe <glen@delfi.ee> 8b23e85
- add checkconfig support

* Fri Feb 12 2016 Adam Osuchowski <adwol@pld-linux.org> 9af6eac
- up to 5.7.3p2

* Fri Dec 11 2015 Elan Ruusamäe <glen@delfi.ee> ae4734f
- enable table-db

* Fri Dec 11 2015 Elan Ruusamäe <glen@delfi.ee> 9127fec
- up to 5.7.3p1, table-db is not built somewhy

* Tue May 12 2015 Elan Ruusamäe <glen@delfi.ee> b207f9a
- up to 5.4.5p1

* Fri Feb 20 2015 Elan Ruusamäe <glen@delfi.ee> badf784
- fix path to ca file

* Fri Feb 20 2015 Elan Ruusamäe <glen@delfi.ee> 4c4577b
- up to 5.4.4p1, filter and queue binaries not built

* Fri May 16 2014 Elan Ruusamäe <glen@delfi.ee> d6b83af
- seems working; rel 1

* Fri May 16 2014 Elan Ruusamäe <glen@delfi.ee> b350f45
- avoid /usr/lib/opensmtpd/opensmtpd dir

